#include "StdInc.h"
#include "RollEm.h"

// Defines
// Structs 
typedef struct _tagDisplayItemMemberVars
{
	Int16 iPos;
	MemHandle hLabel;
} DisplayItemMemberVars;
typedef DisplayItemMemberVars *DisplayItemMemberVarsPtr;

// Vars
DisplayItemMemberVarsPtr g_pDisplayItemMemberVars;

// Funcs
Boolean DisplayItemProc(EventPtr pEvent);
void DrawDisplayItem (FormPtr pForm);

Int16 DoDisplayItemModal (Char *pLabel, Int16 *pPos, Char **pList, Int16 iList)
{
	FormPtr pForm, pOldForm;
	Int16 wResult;

	wResult = 0;
	pOldForm = FrmGetActiveForm();
	if (pForm = FrmInitForm(IDF_DISPLAYITEM))
	{
		// Pre form stuff.
		FrmSetActiveForm(pForm);

		// Do the every time initialization 
		//  of the Sound DisplayItem here.
		g_pDisplayItemMemberVars = MemPtrNew(sizeof(DisplayItemMemberVars));
		if (g_pDisplayItemMemberVars)
		{
			// Set the members vars;
			g_pDisplayItemMemberVars->iPos = *pPos;
			g_pDisplayItemMemberVars->hLabel = SetField (pForm, IDC_ITEM_FIELD, MAX_DISPLAY_TITLE-1, pLabel);
			InitDynamicPopup(pForm, IDC_ITEM_TYPE, IDC_ITEM_LIST, *pPos, pList, iList);

			AutoShiftField(pForm, IDC_ITEM_FIELD, true);

			// Do the DisplayItem.
			DrawDisplayItem(pForm);

			// Show the DisplayItem.
			FrmSetEventHandler(pForm, (FormEventHandlerPtr) DisplayItemProc);
			wResult = FrmDoDialog(pForm);

			if (wResult == IDC_OK)
			{
				*pPos = g_pDisplayItemMemberVars->iPos;
				StrCopy(pLabel, (Char*)MemHandleLock(g_pDisplayItemMemberVars->hLabel));
				MemHandleUnlock(g_pDisplayItemMemberVars->hLabel);
			}
			MemPtrFree(g_pDisplayItemMemberVars);
		}

		// We now return to our other window.
		if (pOldForm)
			FrmSetActiveForm(pOldForm);
		FrmDeleteForm(pForm);
	}

	return wResult;
}

Boolean DisplayItemProc(EventPtr pEvent)
{
	FormPtr pForm = FrmGetActiveForm();
	Boolean bHandled = false;

    switch (pEvent->eType) 
    {
	case ctlSelectEvent:  // A control button was pressed and released.
	{
		switch (pEvent->data.ctlEnter.controlID)
		{
		case IDC_CANCEL:
			bHandled = false;
			break;
		case IDC_OK:
			bHandled = false;
			break;
		default:;
		}
		break;
	}

	case popSelectEvent:
	{
		switch(pEvent->data.popSelect.listID)
		{
        case IDC_ITEM_LIST:
            g_pDisplayItemMemberVars->iPos = pEvent->data.popSelect.selection;
            break;
		}
		break;
	}

	default:
		bHandled = false;
	}

	return bHandled;
}

void DrawDisplayItem (FormPtr pForm)
{
}
