#include "StdInc.h"
#include "RollEm.h"
#include "EditNote.h"
#include "Sound.h"

Boolean EditNoteProc (EventPtr event)
{
	FormPtr pForm = FrmGetActiveForm();
	Boolean bHandled = false;

    switch (event->eType) 
    {
        case ctlSelectEvent:
		{
            switch (event->data.ctlEnter.controlID)
            {
			case IDC_OK:
			{
				FieldPtr pField;
				MemHandle hDuration;

				pField = FrmGetObjectPtr(pForm, FrmGetObjectIndex(pForm, IDC_DURATION_FIELD));
				hDuration = (MemHandle)FldGetTextHandle(pField);
				if (StrAToL((Char*)MemHandleLock(hDuration)) <= 0)
				{
					bHandled = true;
				}
				MemHandleUnlock(hDuration);
				break;
			}
			case IDC_TEST_SOUND:
			{
				FieldPtr pField;
				MemHandle hHertz, hDuration;
				Char *pHertz, *pDuration;

				pField = FrmGetObjectPtr(pForm, FrmGetObjectIndex(pForm, IDC_HERTZ_FIELD));
				hHertz = (MemHandle)FldGetTextHandle(pField);
				pField = FrmGetObjectPtr(pForm, FrmGetObjectIndex(pForm, IDC_DURATION_FIELD));
				hDuration = (MemHandle)FldGetTextHandle(pField);
				PlayNote(StrAToL((Char*)MemHandleLock(hHertz)), StrAToL((Char*)MemHandleLock(hDuration)));
				MemHandleUnlock(hHertz);
				MemHandleUnlock(hDuration);
				bHandled = true;
				break;	
			}
			}
			break;
		}
	}

    return bHandled;
}

UInt16 DoEditNote (NotePtr pNote)
{
	static Boolean bInit = false;
	FormPtr pForm, pOldForm;
	UInt16 wResult;
	MemHandle hHertz, hDuration;
	Char *pHertz, *pDuration;
	Char szTemp [32];

	wResult = 0;
	pOldForm = FrmGetActiveForm();
	if (pForm = FrmInitForm(IDF_EDIT_NOTE))
	{
		// Do the one time initialization 
		//  of the Sound dialog here.
		if (!bInit)
		{
			bInit = true;
		}

		// Do the every time initialization 
		//  of the Sound dialog here.
		hHertz = SetField (pForm, IDC_HERTZ_FIELD, 5, 
			StrLToA(szTemp, (Int32) pNote->uiHertz));
		hDuration = SetField (pForm, IDC_DURATION_FIELD, 5, 
			StrLToA(szTemp, (Int32)pNote->uiDuration));
		FrmSetFocus(pForm, FrmGetObjectIndex(pForm, IDC_HERTZ_FIELD));

		// Show the dialog.
		FrmSetEventHandler(pForm, (FormEventHandlerPtr) EditNoteProc);
		wResult = FrmDoDialog(pForm);

		if (wResult == IDC_OK)
		{
			pHertz = (Char*)MemHandleLock(hHertz);
			pDuration = (Char*)MemHandleLock(hDuration);

			pNote->uiHertz = StrAToL(pHertz);
			pNote->uiDuration = StrAToL(pDuration);
			
			MemHandleUnlock(hHertz);
			MemHandleUnlock(hDuration);
		}

		// We now return to our other window.
		if (pOldForm)
			FrmSetActiveForm(pOldForm);
		FrmDeleteForm(pForm);
	}

	return wResult;
}
