#include "StdInc.h"
#include "RollEm.h"

void InitPrefs ();

MemHandle hMaxRolls;

Boolean PrefsProc (EventPtr event)
{
	FormPtr pForm = FrmGetActiveForm();
	Boolean bHandled = false;

    switch (event->eType) 
    {
    case frmOpenEvent:
    {
		InitPrefs();
		RefreshForm();
		bHandled = true;
        break;
    }

	case frmUpdateEvent:
	{
		FrmDrawForm(pForm);
		bHandled = true;
		break;
	}

    case ctlSelectEvent:
	{
        switch (event->data.ctlEnter.controlID)
        {
            case IDC_OK:
			{
				Int32 lValue;

				lValue = StrAToL((Char*)MemHandleLock(hMaxRolls));
				MemHandleUnlock(hMaxRolls);

				if ((lValue < MIN_ROLLS_SAVED) || (lValue > MAX_ROLLS_SAVED))
				{
	                Char szMinRange [10], szMaxRange [10];

					StrLToA(szMinRange, (Int32)MIN_ROLLS_SAVED);
					StrLToA(szMaxRange, (Int32)MAX_ROLLS_SAVED);
					FrmCustomAlert(IDA_RANGE_ERROR, "rolls", 
						szMinRange, szMaxRange);
					return true;
				}

				g_pPrefs->wSaveRollNumber = lValue;
				g_pPrefs->wDeleteOnExit = GetCheck(pForm, IDC_CHECK_DEL_ROLLS);
//				g_pPrefs->wAdvCustom = GetCheck(pForm, IDC_CHECK_ADV_CUSTOM);
			}
            case IDC_CANCEL:
                FrmReturnToForm(0);
                break;
        }
        bHandled = true;
        break;
	}

	default:
		bHandled = false;
	}

    return bHandled;
}

void InitPrefs ()
{
	FormPtr pForm = FrmGetActiveForm();
	Char szTemp [32];

	SetCheck(pForm, IDC_CHECK_DEL_ROLLS, g_pPrefs->wDeleteOnExit);
//	SetCheck(pForm, IDC_CHECK_ADV_CUSTOM, g_pPrefs->wAdvCustom);

	hMaxRolls = SetField (pForm, IDC_PREFS_MAX_ROLLS, MAX_ROLLS_LEN, 
		StrLToA(szTemp, g_pPrefs->wSaveRollNumber));
}

