#ifndef __ROLLEMUPD_H
#define __ROLLEMUPD_H      1

#ifdef __cplusplus
extern "C" {
#endif

//#define _DEBUG

#define ROLLEM_ID_APP			'RlEm'
#define ROLLEM_DB_DATA			'Data'
#define ROLLEM_DB_ROLL			'Roll'

#define RECORDID_PREFS			'Pref'
#define RECORDID_SOUNDS			'Snds'
#define RECORDID_RESULTS		'Rslt'
#define RECORDID_PAGES			'Page'
#define RECORDID_ROLLS			'Roll'

#define MAX_TITLE_LEN			15
#define MAX_TEMPSTRING_LEN		50

#define MIN_PAGES               1
#define MAX_PAGES               50

#define VERSION_NUMBER			200
#define INIT_PAGES				5
#define INIT_ROLL_SESSION		1
#define INIT_ROLL_NUMBER		8
#define INIT_ADV_CUSTOM			0

#define DEFAULT_PAGES			5

#define IDC_BUTTON_FIRST        IDC_BUTTON_0
#define IDC_BUTTON_LAST         IDC_BUTTON_7
#define NUM_BUTTONS             ((IDC_BUTTON_LAST - IDC_BUTTON_FIRST) + 1)
#define ID2NUM(wId)             (wId - IDC_BUTTON_FIRST)
#define PAGE2REC101(wPage)		(wPage+1)
#define PAGE2REC110(wPage)		(wPage+10)
#define PREFS_RECORD			0
#define RESULTS_RECORD			1
#define SOUNDS_RECORD			2
#define ROLLS_RECORD			3
#define PAGES_RECORD			10

// ************************************************************* //
//                         Enumerations                          //
// ************************************************************* //

typedef enum 
{
    ComparisonEqual=0,
    ComparisonGreater,
    ComparisonLess,
    ComparisonGreaterEqual,
    ComparisonLessEqual,
    ComparisonNotEqual
} Comparison;

typedef enum 
{
    DataTypeNumber=0,
    DataTypeString,
	DataTypeCheck,
    DataTypeCompare,
    DataTypeSound,
	DataTypeRollType,
	DataTypeEnd=255
} DataType;

typedef enum 
{
    RollDisplayNameTitle=0,
    RollDisplayNameRoll,
} RollDisplayName;

typedef enum 
{
	RollDisplayStatSubtotal=0,
    RollDisplayStatTotal,
    RollDisplayStatSum,
    RollDisplayStatMean,
	RollDisplayStatMedian,
    RollDisplayStatMode,
} RollDisplayStat;

// ************************************************************* //
//                          Structures                           //
// ************************************************************* //

// Prefs
typedef struct _tagPrefs101
{
    UInt16 wVersion;
    UInt16 wCurrentPage;
    UInt16 wTotalPages;
    UInt16 wCurrentButton;
    Int32 lLastResult;
} Prefs101;
typedef Prefs101 *Prefs101Ptr;

typedef struct _tagPrefs110
{
    UInt16 wVersion;
    UInt16 wTotalPages;
} Prefs110;
typedef Prefs110 *Prefs110Ptr;

// Die rolls
typedef struct _tagDieRoll101
{
    Char szTitle [MAX_TITLE_LEN];
    Int16 iDie;
    Int16 iNumber;
    Int16 iModifier;
    Int16 iBest;
    UInt8 iBeepType1;
    UInt8 iBeepType2;
    UInt8 iBeepCompare1; 
    UInt8 iBeepCompare2; 
    UInt8 iSuccessCompare; 
    Int32 lBeepValue1;
    Int32 lBeepValue2;
    Int32 lSuccessValue;
} DieRoll101;
typedef DieRoll101 *DieRoll101Ptr;

typedef struct _tagDieRoll110
{ 
    Char szTitle [MAX_TITLE_LEN+1];
    Int32 lField00; //iDie
    Int32 lField01; //iNumber
    Int32 lField02; //iModifier
    Int32 lField03; //iBest
    Int32 lField04; //iBeepType1
    Int32 lField05; //iBeepType2
    Int32 lField06; //iBeepCompare1
    Int32 lField07; //iBeepCompare2
    Int32 lField08; //iSuccessCompare
    Int32 lField09; //lBeepValue1
    Int32 lField10; //lBeepValue2
    Int32 lField11; //lSuccessValue
    Int32 lField12; //lMisc
    Int32 lField13; //lMisc
    Int32 lField14; //lMisc
    Int32 lField15; //lMisc
    Int32 lField16; //lMisc
    Int32 lField17; //lMisc
    Int32 lField18; //lMisc
    Int32 lField19; //lMisc
    Int32 lField20; //lMisc
    Int32 lField21; //lMisc
    Int32 lField22; //lMisc
    Int32 lField23; //lMisc
    Int32 lField24; //lMisc
} DieRoll110;
typedef DieRoll110 *DieRoll110Ptr;

// Results
typedef struct _tagResults110
{
    UInt16 wCurrentPage;
    UInt16 wCurrentButton;
	Int32 lLastResult;
	Int32 lLastRolls [1];
} Results110;
typedef Results110 *Results110Ptr;

// Prefs
typedef struct _tagPrefs200
{
    UInt16 wVersion;
    UInt16 wTotalPages:8;
	UInt16 wSaveRollNumber:8;
	UInt16 wDeleteOnExit:1;
	UInt16 wAdvCustom:1;
	UInt16 wReserved:14;
	UInt16 wRollDisplayName;
	UInt16 wRollDisplayStat;
} Prefs200;
typedef Prefs200 *Prefs200Ptr;

// Results
typedef struct _tagResults200
{
    UInt16 wCurrentPage;
    UInt16 wCurrentButton;
	Int32 lLastResult;
} Results200;
typedef Results200 *Results200Ptr;

//typedef struct _tagNote
//{
//    UInt16 uiHertz;
//    UInt16 uiDuration;
//} Note;
//typedef Note *NotePtr;

// ************************************************************* //
//                           Externs                             //
// ************************************************************* //

//extern DmOpenRef g_hRollEmDB;

// ************************************************************* //
//                     Forward Declarations                      //
// ************************************************************* //

#ifdef __cplusplus
}
#endif

#endif
